// Arduino f-metr
// выход Т2 (pin D3) и вход Т0 (pin D4)- соединены перемычкой

#include<LiquidCrystal.h>               // lib Display
#include <EEPROM.h>                     // --"--  EEPROM

#define Rst 7                           // pin сброса внешнего счетчика
#define BTN1 2                          // кнопка 1 (PIN_2 --- КНОПКА 1 --- GND)
#define BTN2 12                         // кнопка 2 (PIN_12 --- КНОПКА 2 --- GND)
#define BTN3 11                         // кнопка 3 (PIN_11 --- КНОПКА 3 --- GND)
 
  byte Kg = 8;                          // Коэффициент деления счетчика на входе
  byte b;                               // показания счетчика
  unsigned long f = 0;                  // частота (Гц)
  unsigned int count;                   // cчетчик переполнения Т1
  int Kk = 3730;                        // коэффициент коррекции на 16 МГц
  const String del = "      ";          // очистка части дисплея
  boolean Flag1;                        // флаг отображения 1 строки
//-----------------------------------------------------------------
  byte INIT_KEY = 123;                  // ключ первого запуска EEPROM, на выбор: 0-254
  byte Pp = 0;                          // режим работы 
  byte Km = 1;                          // коэффициент множитель щупа-делителя
  byte hi;                              // старший байт int
  byte low;                             // младший байт int
  unsigned int Tmr1;                    // таймеры кнопок
  unsigned int Tmr2;
  unsigned int Tmr3;
  unsigned int T_out = 20000;           // таймаут антидребезга
  int btnState;
  boolean Flag_save;                    // флаг записи
  unsigned int Score2;                  // длительность нажатия BTN2
  unsigned int Score3;                  // длительность нажатия BTN3
  unsigned int Vol = 20;               // изменение скорости переключения

LiquidCrystal lcd(14,15,16,17,18,19);   // используем аналоговые pin'ы А0-А5

void setup() {
      pinMode(3, OUTPUT);               // выход Т2 - pin 3
      pinMode(4, INPUT);                // вход Т0 - pin 4
      pinMode(6, OUTPUT);               // выход T0 - pin 6
      pinMode(5, INPUT);                // вход T1 - pin 5
          pinMode(8, INPUT);            // --- счетчик ---
          pinMode(9, INPUT); 
          pinMode(10, INPUT); 
          pinMode(Rst, OUTPUT);         // pin сброса счетчика на входе
      pinMode(BTN1, INPUT_PULLUP);      // --- кнопки ---
      pinMode(BTN2, INPUT_PULLUP);
      pinMode(BTN3, INPUT_PULLUP); 
   
// ----------------Инициализация LCD ---------------------
  lcd.begin(16,2);
  lcd.setCursor(0,0); lcd.print(" ARDUINO f-metr");      
// --------------- чтение EEPROM -------------------------
    if (EEPROM.read(0) == INIT_KEY) {                 // если ключ установлен
      hi = EEPROM.read(2); low = EEPROM.read(3);      // чтение EEPROM
        Kk = word(hi, low);                           // "собираем" число из байт                 
   }     
// -------------------------------------------------------

noInterrupts();     
            // таймер 2 - 250 Гц
    OCR2A = 249;
    OCR2B = 125;
    TCCR2A = 0; TCCR2B = 0;  
    TCCR2A = _BV(COM2B1) | _BV(COM2B0) | _BV(WGM21) | _BV(WGM20);  // режим быстрого ШИМ с верхним пределом
    TCCR2B = _BV(WGM22) | _BV(CS22) | _BV(CS21);                   // установка предделителя в 256 и запуск таймера
  
            // таймер 0 выход - 1 Гц
    OCR0A = 249;
    TCCR0A = 0; TCCR0B = 0;
    TCCR0A = _BV(COM0A1) | _BV(WGM00) | _BV(WGM01);                 //  режим ШИМ
    TCCR0B = _BV(CS02) | _BV(CS01);                                
    
            // таймер 1 - счетчик, вход - pin D5
    TCCR1A = 0; TCCR1B = 0; TCNT1 = 0;
    TCCR1B = _BV(CS12) | _BV(CS11) | _BV(CS10) ; 
      TIFR1 = 1 << TOV1;

interrupts();                         // включить глобальные прерывания
}
                  // вывод на экран
void my1LCD () {                                  // 1 строка
          float ff;                                     // частота в МГц (кГц)
       lcd.setCursor(4,0); lcd.print(del + del);
       lcd.setCursor(0,0); lcd.print("f = ");
       if(f < 1000) {
          lcd.print(f); lcd.print(" Hz");}
       else {
          if(f >= 1000000){
              ff = (float)f/1000000.0;
            lcd.print(ff,6); lcd.print(" MHz");}
          else {
              ff = (float)f/1000.0;
            lcd.print(ff,3); lcd.print(" kHz");}
       }
}
void my2LCD () {                                        // 2 строка
       String str1;
        int val;
         lcd.setCursor(4,1);lcd.print(del + del);             
                 switch (Pp) {
      case 0: str1 = " 1s  " + del + " x"; val = Km; break;
      case 1: str1 = " Km = "; val = Km; break;
      case 2: str1 = " Kk = "; val = Kk; break;
      case 3: str1 = "save?: L=NO R=OK"; break;
      case 4: str1 = " --- saved ---"; break;   
      }
            lcd.setCursor(0,1); lcd.print(str1); 
            if (Pp < 3) {lcd.print(val);}
}

void corr() {                   //---- расчет коррекции ----
    unsigned long calc_Kk;
     unsigned int K;       
    if (f > 1000) {                     // если > 1 кГц, то корректируем
          K = abs (Kk);
          calc_Kk = f/1000;             //  частота в кГц       
            calc_Kk *= (K);             //  умножаем на Kk     |16 МГЦ - Kk       
              calc_Kk /= 16;            //  делим на 16 кГц    | f МГц - х
              calc_Kk /= 1000;
       if (Kk < 0) {                    // корректируем
          f -= calc_Kk; }
       else { f += calc_Kk; }
    }
}

void freq_calc() {              //---- расчет частоты ------
    f = (unsigned long)count * 65536 + TCNT1; 
       f *= (Kg);                                 // умножаем на коэффициент деления счетчика на входе
           f += b;                                // добавляем значение счетчика-делителя
              f *= (Km);                          // множитель щупа-делителя
       corr();                                    // коррекция
}
void pauza () {
  asm("nop"); asm("nop"); asm("nop"); 
  asm("nop"); asm("nop"); asm("nop"); 
}
//==========================---- BTN+ ----=======================

void save() {                       //--- запись в EEPROM ---
        hi  = highByte(Kk);                   // старший байт 
        low = lowByte(Kk);                    // младший байт
            EEPROM.update(2, hi); 
            EEPROM.update(3, low);
          EEPROM.update(0, INIT_KEY);         // обновляем ключ
}
void mod_Pp() {                    // режим работы         
      Pp++; 
      if (Flag_save) { Pp = 3; Flag_save = false;}
      else { if (Pp > 2) { Pp = 0; } }
                my2LCD();
}
void chg_val2() {
        switch (Pp) {
  case 0: break;       
  case 1: Km--; if (Score2 >= Vol) { Km -= 9;}
              if (Km < 1) { Km = 1; } 
          break;
  case 2: Kk--; if (Score2 >= Vol) { Kk -= 9;}
              if (Score2 >= Vol * 2) { Kk -= 90;}
       if (Kk < -32767) { Kk = -32767;} 
              Flag_save = true; break;
  case 3: Pp = 0; Flag_save = false; break;
  }
              my2LCD();
}
void chg_val3() {
        switch (Pp) {
  case 0: break;       
  case 1: Km++; if (Score3 >= Vol) { Km += 9;}
              if (Km > 255) { Km = 255; }  
          break;
  case 2: Kk++; if (Score3 >= Vol) { Kk += 9;}
            if (Score3 >= Vol * 2) { Kk += 90;}
             if (Kk > 32767) { Kk = 32767;} 
               Flag_save = true; break;
  case 3:
       Pp = 4; my2LCD(); save(); Pp = 0; Flag_save = false;
           break;
  }
              my2LCD();
}

//===================================================================================== 
void loop() {                   //---- бесконечный цикл ----
                                           // измерение 
    if (bitRead(PIND, 6)==1) {                         // то же, что digitalRead(6)==1, только за 1 такт
          if (!Flag1) {Flag1 = true;} 
       if(TIFR1 & (1 << TOV1)) {count++; TIFR1 = 1 << TOV1;}  // проверяем переполнение TCNT1
    }
    else {                                // вывод на экран
      if (Flag1) {
          Flag1 = false;  
             if(TIFR1 & (1 << TOV1)) {count++; TIFR1 = 1 << TOV1;}    // на всякий случай
                    b = PINB & B00000111;                   // читаем значения Pin 8,9,10
                digitalWrite(Rst,0);                        // сброс счетчика-делителя
          freq_calc();                                      // определяем частоту
            count = 0; TCNT1 = 0;                           // обнуляем счетные регистры
                digitalWrite(Rst,1);                        // перевод счетчика в режим счета
                    my1LCD();                               // отображение частоты
                        my2LCD();                           // отоюражение 2 строки
      }     
   }
//------------------------------- кнопки -----------------------------
        
          btnState = !digitalRead(BTN3);      // контроль BTN3
                if (btnState == 1) { 
                      Tmr3++; if (Tmr3 >= T_out) { Tmr3 = 0; Score3++; chg_val3(); } }
                else {Tmr3 = 0; Score3 = 0;}
          btnState = !digitalRead(BTN2);      // контроль BTN2
                if (btnState == 1) { 
                      Tmr2++; if (Tmr2 >= T_out) { Tmr2 = 0; Score2++; chg_val2(); } }
                else {Tmr2 = 0; Score2 = 0;}
          btnState = !digitalRead(BTN1);      // контроль BTN1
                if (btnState == 1) { 
                      Tmr1++; if (Tmr1 >= T_out) { Tmr1 = 0; mod_Pp(); } }
                else {Tmr1 = 0;}
  
                                      pauza ();               // пауза                         
}
